extern void process(char *fnam, char *main_seq, char *ofnam) ;
extern void decNoteB(char *nam) ;
extern void decNoteS(char *nam) ;
extern void decNoteM(char *nam) ;
extern int decSerList(int lev, double bblen, ParList **rvp) ;
extern BaList * decBaSpec(BaList **prvp, char *enc, int f_slide) ;
extern BaList * addBaSpec(BaList **prvp, int tim, double carr, double freq, double vol, int f_slide) ;
extern EnvList * decEnvSpec(EnvList **prvp, char *enc, int f_slide, double adjadj) ;
extern EnvList * addEnvSpec(EnvList **prvp, int tim, double adj, double vol, int f_slide) ;
extern MixList * decMixSpec(char *enc) ;
extern void setupSlide(double *arr, double val0, double val1) ;
extern int deltaCount(int len, ...) ;
extern int getWord() ;
extern void ungetWord() ;
extern char * getName() ;
extern int getNum(char **pp, double *rvp) ;
extern int getTime(char **pp, int prev, int *rvp) ;
extern void readFile(char *fnam) ;
extern Note * findNote(char *nam) ;
extern Sequence * findSeq(char *nam) ;
extern void dumpAll() ;
extern void dumpNoteS(NoteS *nn) ;
extern void dumpNoteB(NoteB *nn) ;
extern void dumpNoteM(NoteM *nn) ;
extern void dumpPar(ParList *par, int off) ;
extern int main(int ac, char **av) ;
extern void addOptions(int ac, char **av) ;
extern void processOptions(int ac, char **av, int f_main) ;
extern void setupTables() ;
extern int * initPlay(int bsiz, int pre, int len) ;
extern int playChunk() ;
extern void playAdd(Event *ev) ;
extern int playNoteB(PlayB *pl) ;
extern int playS_2x_m16(PlayS *pl) ;
extern int playS_2x_s16(PlayS *pl) ;
extern int playS_4x_m16(PlayS *pl) ;
extern int playS_4x_s16(PlayS *pl) ;
extern double envLength(EnvList *en) ;
extern void renderSequence(Sequence *seq, int fd, int blen, int f_wav, int f_loop, int f_mono, double vol, int *pre_rvp, int *len_rvp) ;
extern inline void writeData(int fd, char *p0, char *p1) ;
extern void clearEvents() ;
extern int cmpEvents(Event **ep1, Event **ep2) ;
extern int sortEvents() ;
extern int expandSeq(Sequence *seq, int tim) ;
extern void expandPar(ParList *par, int tim) ;
extern void addNoteS(NoteS *nn, int tim, double vol) ;
extern void addNoteB(NoteB *nn, int tim, double vol) ;
extern void addNote(Note *nn, int tim, double vol) ;
extern void expandSeries(ParList *par, int tim) ;
extern double findMaxVol() ;
extern char * writeWAV(int tlen, int rate, int bps, int f_stereo) ;
extern void dumpEvents() ;
extern int FUNC_NAM(PlayS *pl) ;
extern void * CAlloc(size_t len) ;
extern void * Alloc(size_t len) ;
extern char * DataDup(char *dat, int datlen) ;
extern char * StrDup(char *nam) ;
extern char * StrPrintF(char *fmt, ...) ;
extern char * StrVPrintF(char *fmt, va_list ap) ;
extern void error(char *fmt, ...) ;
extern void errorE(char *fmt, ...) ;
extern void warn(char *fmt, ...) ;
extern void debug(char *fmt, ...) ;
extern int packCC(char *cp) ;
